<!DOCTYPE html>
<html lang="en">
  <head>
    <meta charset="UTF-8" />
    <meta name="viewport" content="width=device-width, initial-scale=1.0" />
    <meta http-equiv="X-UA-Compatible" content="ie=edge" />
    <title>Twilio Flex - Ticket Sidebar</title>
    <link href="https://fonts.googleapis.com/css?family=Open+Sans" rel="stylesheet" />
    <link href="https://cdn.jsdelivr.net/npm/bootstrap@5.1.2/dist/css/bootstrap.min.css" rel="stylesheet" integrity="sha384-uWxY/CJNBR+1zjPWmfnSnVxwRheevXITnMqoEIeG1LJrdI0GlVs/9cVSyPYXdcSF" crossorigin="anonymous">
    <link rel="stylesheet" href="https://cdn.jsdelivr.net/npm/bootstrap-icons@1.6.1/font/bootstrap-icons.css">

    <script type="text/javascript" src="https://static.zdassets.com/zendesk_app_framework_sdk/2.0/zaf_sdk.min.js"></script>
    <script src="https://code.jquery.com/jquery-3.6.0.min.js" integrity="sha256-/xUj+3OJU5yExlq6GSYGSHk7tPXikynS7ogEvDej/m4=" crossorigin="anonymous"></script>
    <script src="https://cdn.jsdelivr.net/npm/bootstrap@5.1.2/dist/js/bootstrap.bundle.min.js" integrity="sha384-kQtW33rZJAHjgefvhyyzcGF3C5TFyBQBA13V1RKPf4uH+bwyzQxZ6CmMZHmNBEfJ" crossorigin="anonymous"></script>

    <style>
      body { font-size: .7rem !important; }
      .wrapper{ margin-top:5px; }
      .title { font-size: 12pt; }
      .row { margin-top: 3px !important; }
      .btn { font-size: .7rem !important; } 
      .dropdown-item {font-size: .7rem !important;}
      .col-form-label-sm { font-size: .7rem !important;}
      .btn-size { width: 150px; }
    </style>
  </head>
  <body>
    <div id="root" class="container wrapper">
        <!-- create bootstrap form for Flex Contact Panel -->

        <div class="row">
            <div class="col col-lg-12">
                <nav>
                    <div class="nav nav-tabs" id="nav-tab" role="tablist">
                      <button class="nav-link active" id="nav-home-tab" data-bs-toggle="tab" data-bs-target="#nav-home" type="button" role="tab" aria-controls="nav-home" aria-selected="true">Contact Info</button>
                      <button class="nav-link" id="nav-profile-tab" data-bs-toggle="tab" data-bs-target="#nav-profile" type="button" role="tab" aria-controls="nav-profile" aria-selected="false">Message</button>
                    </div>
                  </nav>

            </div>
        </div>

        <div class="row">
            <div class="col col-lg-12">
                <div class="tab-content" id="nav-tabContent">
                    <div class="tab-pane fade show active" id="nav-home" role="tabpanel" aria-labelledby="nav-home-tab">
                        <div class="row">
                            <div class="col col-lg-12"><p>&nbsp;</p></div>
                        </div>                        

                        <!-- name -->
                        <div class="row">
                            <div class="col col-lg-2 col-md-2 col-sm-2">
                                <label for="contactName" class="col-sm-2 col-form-label-sm">Name</label>
                            </div>
                            <div class="col col-lg-10 col-md-10  col-sm-10">
                                <label id="contactName"  class="col-sm-2 col-form-label-sm"  style="width:100%;">John Doe</label>
                            </div> 

                        </div>                        

                        <!-- name -->
                        <div class="row">
                            <div class="col col-lg-2 col-md-2 col-sm-2">
                                <label for="contactPhone" class="col-sm-2 col-form-label-sm" >Phone</label>
                            </div>
                            <div class="col col-lg-6 col-md-6  col-sm-6">
                                <!-- <a id="contactPhone" class="form-control-sm"  href="#" onclick="return false;" data-phone="+13035706579">+13035706579</a> -->
                                <button id="contactPhone" type="button" class="btn btn-primary btn-small btn-size" data-phone="" >
                                  <i class="bi-telephone"></i>&nbsp;
                                </button>
                            </div> 
                            <div class="col col-lg-4 col-md-4  col-sm-4">
                                <p>&nbsp;</p>
                            </div>
                        </div>    

                        <!-- name -->
                        <div class="row">
                            <div class="col col-lg-2 col-md-2 col-sm-2">
                                <label for="contactMobile" class="col-sm-2 col-form-label-sm">Mobile</label>
                            </div>
                            <div class="col col-lg-6 col-md-6  col-sm-6">

                              <div class="btn-group dropend">
                                <button id="contactMobile" type="button" class="btn btn-primary btn-small dropdown-toggle btn-size" data-bs-toggle="dropdown" aria-expanded="false">
                                  <i class="bi-telephone"></i>&nbsp;+13035706579
                                </button>
                                <ul class="dropdown-menu">
                                  <li><a class="dropdown-item" href="#">Place Call</a></li>
                                  <li><a id="sendMessageModal" class="dropdown-item" href="#">Message Contact</a></li>
                                </ul>
                              </div>





                
                            </div> 
                            <div class="col col-lg-4 col-md-4  col-sm-4">
                                <p>&nbsp;</p>
                            </div>
                        </div>    


                    </div>
                    <div class="tab-pane fade" id="nav-profile" role="tabpanel" aria-labelledby="nav-profile-tab">
                        
                        <div class="row">
                            <div class="col col-lg-12"><p>&nbsp;</p></div>
                        </div>                        
                        <div class="row">
                            <div class="col col-lg-12"><p>Send a Message</p></div>
                        </div>
                        <div class="row">
                            <div class="col col-lg-12"><textarea cols="40" rows="5" id="message"></textarea></div>
                        </div>                        
                        <div class="row">
                            <div class="col col-lg-12"><a id="sendMessage" class="btn btn-primary btn-sm" onclick="return false;">Send</a></div>
                        </div>                     
                    </div>

                  </div>
            </div>
        </div>

    </div> 
    <input id="dealId" type="hidden" />
    <input id="contactId" type="hidden"/> 
    
    
    <script>

        $(function (){
            var client;
            // var global;
            // var undefined;
            var backgroundInstanceGuid;


          // handler for formatting phone number to e.164
          function formatPhoneNumber(phoneNumberString) {
            return phoneNumberString
              .trim()
              .replace(/\D/g, '')
              .replace(/^([^\+])/g, '+$1')
              .replace(/(\d{6})(\d{3})(\d{3})/, '$1 $2 $3');
          }

           // handler to execute upon instantiation (active) of the sidebar extension
          function activate() {
              client.get('deal')
                .then(deal =>{
                  console.log('===== DEAL =======')
                  console.log(deal);
                })
              client.get('deal.contact')
                .then(contact =>{
                    console.log('===== DEAL CONTACT =======')
                    console.log(contact);
                    $('#contactName').html(contact['deal.contact'].firstName + ' ' + contact['deal.contact'].lastName);
                    $('#contactPhone').attr('data-phone', contact['deal.contact'].phone);
                    $('#contactPhone').html('<i class="bi-telephone"></i>&nbsp;&nbsp;' + contact['deal.contact'].phone);

                    $('#contactMobile').attr('data-mobile', contact['deal.contact'].mobile);
                    $('#contactMobile').html('<i class="bi-telephone"></i>&nbsp;&nbsp;' + contact['deal.contact'].mobile);
                    return;
                });

          } 
          
          function onAppActivated() {
            if (!backgroundInstanceGuid) {
              return;
            }
  
            client.instance(backgroundInstanceGuid).trigger('deal.app.activated', {
              ticketId: client._context.ticketId,
              instanceGuid: client._context.instanceGuid,
            });
          }
  
          function onAppDeactivated() {
            if (!backgroundInstanceGuid) {
              return;
            }
  
            client.instance(backgroundInstanceGuid).trigger('deal.app.deactivated');
          }
          
          //    initialize the ZAF client
          function init() {
            client.get('instances').then(function(data) {
              Object.keys(data.instances).forEach(function(instanceGuid) {
                if (data.instances[instanceGuid].location === 'background') {
                  backgroundInstanceGuid = instanceGuid;
                }
              });
  
              if (backgroundInstanceGuid) {
                activate();
                onAppActivated();
                return;
              }
  
              setTimeout(function() {
                init();
              }, 250);
            });
          } 
          
          // Initialise the Zendesk JavaScript API client
          client = ZAFClient.init();
  
          //    ZAF client event handlers
          client.on('app.registered', init);
          client.on('app.activated', onAppActivated);
          client.on('app.deactivated', onAppDeactivated); 
          
          
          // handler for click to dial
          $('#contactPhone').on('click',function(){
             let dialToDial = $('#contactPhone').val()
              console.log('dial contact')
              console.log(backgroundInstanceGuid);
              client.instance(backgroundInstanceGuid).trigger('click_to_dial', {
                  type: 'deal',
                  phone: $('#contactPhone').attr('data-phone'),
                  dealId: client._context.dealId,
                  instanceGuid: client._context.instanceGuid
              })
          })

          $('#sendMessageModal').on('click', function(){
            var mobile = $('#contactMobile').attr('data-mobile');
            var name = $('#contactName').html();

            client.invoke('instances.create', {
              location: 'modal',
              url: 'assets/smsModal.html?phone='+ mobile + '&name=' + name,
              size: {
                width: '400px',
               // height: '300px'
              }
            }).then(function(modalContext) {
              var modalClient = client.instance(modalContext['instances.create'][0].instanceGuid);
              modalClient.on('modal.close', function(){
                // The modal has been closed
              });
            });
          });


        })

        // ((document, global, undefined) => {
        //   var client;
        //   var backgroundInstanceGuid;


        //   // handler for formatting phone number to e.164
        //   function formatPhoneNumber(phoneNumberString) {
        //     return phoneNumberString
        //       .trim()
        //       .replace(/\D/g, '')
        //       .replace(/^([^\+])/g, '+$1')
        //       .replace(/(\d{6})(\d{3})(\d{3})/, '$1 $2 $3');
        //   }
  
        //   // handler to execute upon instantiation (active) of the sidebar extension
        //   function activate() {
        //       let deal = client.get(deal);
        //       console.log('============')
        //       console.log(deal);

        //   }
  
        //   function onAppActivated() {
        //     if (!backgroundInstanceGuid) {
        //       return;
        //     }
  
        //     client.instance(backgroundInstanceGuid).trigger('ticket.app.activated', {
        //       ticketId: client._context.ticketId,
        //       instanceGuid: client._context.instanceGuid,
        //     });
        //   }
  
        //   function onAppDeactivated() {
        //     if (!backgroundInstanceGuid) {
        //       return;
        //     }
  
        //     client.instance(backgroundInstanceGuid).trigger('ticket.app.deactivated');
        //   }
  
        //   //    initialize the ZAF client
        //   function init() {
        //     client.get('instances').then(function(data) {
        //       Object.keys(data.instances).forEach(function(instanceGuid) {
        //         if (data.instances[instanceGuid].location === 'background') {
        //           backgroundInstanceGuid = instanceGuid;
        //         }
        //       });
  
        //       if (backgroundInstanceGuid) {
        //         activate();
        //         onAppActivated();
        //         return;
        //       }
  
        //       setTimeout(function() {
        //         init();
        //       }, 250);
        //     });
        //   }
  
        //   // Initialise the Zendesk JavaScript API client
        //   client = global.ZAFClient.init();
  
        //   //    ZAF client event handlers
        //   client.on('app.registered', init);
        //   client.on('app.activated', onAppActivated);
        //   client.on('app.deactivated', onAppDeactivated);
        // })(document, window);
      </script>    


  </body>
</html>